//+------------------------------------------------------------------+
//|                                                       CCI T3.mq4 |
//+------------------------------------------------------------------+
#property copyright "www,forex-station.com"
#property link      "www,forex-station.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int    CCIPeriod  = 50;
extern int    CCIPrice   = PRICE_TYPICAL;
extern int    T3Period   = 20;
extern double T3Hot      = 0.7;
extern bool   T3Original = false;
extern double OverSold   = -100;
extern double OverBought =  100;

double cci[];
double prices[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,cci);
      SetIndexBuffer(1,prices);
         SetLevelValue(0,OverBought);
         SetLevelValue(1,OverSold);
   IndicatorShortName("CCI ("+CCIPeriod+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      prices[i]  = iMA(NULL,0,1,0,MODE_SMA,CCIPrice,i);
      double avg = 0; for(k=0; k<CCIPeriod; k++) avg +=         prices[i+k];      avg /= CCIPeriod;
      double dev = 0; for(k=0; k<CCIPeriod; k++) dev += MathAbs(prices[i+k]-avg); dev /= CCIPeriod;
         if (dev!=0)
               cci[i] = iT3((prices[i]-avg)/(0.015*dev),T3Period,T3Hot,T3Original,i);
         else  cci[i] = iT3(0                          ,T3Period,T3Hot,T3Original,i);
   }
   return(0);
}


//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

double workT3[][6];
double workT3Coeffs[][6];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define _c4     4
#define _alpha  5

//
//
//
//
//

double iT3(double price, double period, double hot, bool original, int shift, int forInstance=0)
{
   if (ArrayRange(workT3,0) !=Bars)                  ArrayResize(workT3,Bars);
   if (ArrayRange(workT3Coeffs,0) < (forInstance+1)) ArrayResize(workT3Coeffs,forInstance+1);

   if (workT3Coeffs[forInstance][_period] != period)
   {
     workT3Coeffs[forInstance][_period] = period;
        double a = hot;
            workT3Coeffs[forInstance][_c1] = -a*a*a;
            workT3Coeffs[forInstance][_c2] = 3*a*a+3*a*a*a;
            workT3Coeffs[forInstance][_c3] = -6*a*a-3*a-3*a*a*a;
            workT3Coeffs[forInstance][_c4] = 1+3*a+a*a*a+3*a*a;
            if (original)
                 workT3Coeffs[forInstance][_alpha] = 2.0/(1.0 + period);
            else workT3Coeffs[forInstance][_alpha] = 2.0/(2.0 + (period-1.0)/2.0);
   }
   
   //
   //
   //
   //
   //
   
   int buffer = forInstance*6;
   int i = Bars-shift-1;
   if (i < 1)
      {
         workT3[i][0+buffer] = price;
         workT3[i][1+buffer] = price;
         workT3[i][2+buffer] = price;
         workT3[i][3+buffer] = price;
         workT3[i][4+buffer] = price;
         workT3[i][5+buffer] = price;
      }
   else
      {
         workT3[i][0+buffer] = workT3[i-1][0+buffer]+workT3Coeffs[forInstance][_alpha]*(price              -workT3[i-1][0+buffer]);
         workT3[i][1+buffer] = workT3[i-1][1+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][0+buffer]-workT3[i-1][1+buffer]);
         workT3[i][2+buffer] = workT3[i-1][2+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][1+buffer]-workT3[i-1][2+buffer]);
         workT3[i][3+buffer] = workT3[i-1][3+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][2+buffer]-workT3[i-1][3+buffer]);
         workT3[i][4+buffer] = workT3[i-1][4+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][3+buffer]-workT3[i-1][4+buffer]);
         workT3[i][5+buffer] = workT3[i-1][5+buffer]+workT3Coeffs[forInstance][_alpha]*(workT3[i][4+buffer]-workT3[i-1][5+buffer]);
      }

   //
   //
   //
   //
   //
   
   return(workT3Coeffs[forInstance][_c1]*workT3[i][5+buffer] + 
          workT3Coeffs[forInstance][_c2]*workT3[i][4+buffer] + 
          workT3Coeffs[forInstance][_c3]*workT3[i][3+buffer] + 
          workT3Coeffs[forInstance][_c4]*workT3[i][2+buffer]);
}